commit dd747fc548fe6038b035d4b37b63ddb97374c444
Author: Lukáš Vlček <vlcek@net-inout.cz>
Date:   Sat Apr 16 21:42:23 2022 +0200

    API regenerated

diff --git a/webapp/api/.openapi-generator/FILES b/webapp/api/.openapi-generator/FILES
index 16b445e..a80cd4f 100644
--- a/webapp/api/.openapi-generator/FILES
+++ b/webapp/api/.openapi-generator/FILES
@@ -1,6 +1,5 @@
 .gitignore
 .npmignore
-.openapi-generator-ignore
 api.ts
 base.ts
 common.ts
diff --git a/webapp/api/api.ts b/webapp/api/api.ts
index 0ff684a..fb34253 100644
--- a/webapp/api/api.ts
+++ b/webapp/api/api.ts
@@ -21,19 +21,6 @@ import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObj
 // @ts-ignore
 import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from './base';
 
-/**
- * 
- * @export
- * @interface AnnotationGetRequest
- */
-export interface AnnotationGetRequest {
-    /**
-     * 
-     * @type {string}
-     * @memberof AnnotationGetRequest
-     */
-    'annotationId'?: string;
-}
 /**
  * 
  * @export
@@ -228,25 +215,6 @@ export interface DocumentListInfo {
      */
     'annotatingUsers'?: Array<UserInfo> | null;
 }
-/**
- * 
- * @export
- * @interface DocumentListRequest
- */
-export interface DocumentListRequest {
-    /**
-     * 
-     * @type {number}
-     * @memberof DocumentListRequest
-     */
-    'pageIndex'?: number;
-    /**
-     * 
-     * @type {number}
-     * @memberof DocumentListRequest
-     */
-    'pageSize'?: number;
-}
 /**
  * 
  * @export
@@ -693,12 +661,15 @@ export const AnnotationApiAxiosParamCreator = function (configuration?: Configur
     return {
         /**
          * 
-         * @param {AnnotationGetRequest} [annotationGetRequest] 
+         * @param {string} annotationId 
          * @param {*} [options] Override http request option.
          * @throws {RequiredError}
          */
-        annotationGet: async (annotationGetRequest?: AnnotationGetRequest, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
-            const localVarPath = `/annotation`;
+        annotationAnnotationIdGet: async (annotationId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
+            // verify required parameter 'annotationId' is not null or undefined
+            assertParamExists('annotationAnnotationIdGet', 'annotationId', annotationId)
+            const localVarPath = `/annotation/{annotationId}`
+                .replace(`{${"annotationId"}}`, encodeURIComponent(String(annotationId)));
             // use dummy base URL string because the URL constructor only accepts absolute URLs.
             const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
             let baseOptions;
@@ -712,12 +683,9 @@ export const AnnotationApiAxiosParamCreator = function (configuration?: Configur
 
 
     
-            localVarHeaderParameter['Content-Type'] = 'application/json';
-
             setSearchParams(localVarUrlObj, localVarQueryParameter);
             let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
             localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
-            localVarRequestOptions.data = serializeDataIfNeeded(annotationGetRequest, localVarRequestOptions, configuration)
 
             return {
                 url: toPathString(localVarUrlObj),
@@ -769,12 +737,12 @@ export const AnnotationApiFp = function(configuration?: Configuration) {
     return {
         /**
          * 
-         * @param {AnnotationGetRequest} [annotationGetRequest] 
+         * @param {string} annotationId 
          * @param {*} [options] Override http request option.
          * @throws {RequiredError}
          */
-        async annotationGet(annotationGetRequest?: AnnotationGetRequest, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AnnotationInfo>> {
-            const localVarAxiosArgs = await localVarAxiosParamCreator.annotationGet(annotationGetRequest, options);
+        async annotationAnnotationIdGet(annotationId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AnnotationInfo>> {
+            const localVarAxiosArgs = await localVarAxiosParamCreator.annotationAnnotationIdGet(annotationId, options);
             return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
         },
         /**
@@ -799,12 +767,12 @@ export const AnnotationApiFactory = function (configuration?: Configuration, bas
     return {
         /**
          * 
-         * @param {AnnotationGetRequest} [annotationGetRequest] 
+         * @param {string} annotationId 
          * @param {*} [options] Override http request option.
          * @throws {RequiredError}
          */
-        annotationGet(annotationGetRequest?: AnnotationGetRequest, options?: any): AxiosPromise<AnnotationInfo> {
-            return localVarFp.annotationGet(annotationGetRequest, options).then((request) => request(axios, basePath));
+        annotationAnnotationIdGet(annotationId: string, options?: any): AxiosPromise<AnnotationInfo> {
+            return localVarFp.annotationAnnotationIdGet(annotationId, options).then((request) => request(axios, basePath));
         },
         /**
          * 
@@ -827,13 +795,13 @@ export const AnnotationApiFactory = function (configuration?: Configuration, bas
 export class AnnotationApi extends BaseAPI {
     /**
      * 
-     * @param {AnnotationGetRequest} [annotationGetRequest] 
+     * @param {string} annotationId 
      * @param {*} [options] Override http request option.
      * @throws {RequiredError}
      * @memberof AnnotationApi
      */
-    public annotationGet(annotationGetRequest?: AnnotationGetRequest, options?: AxiosRequestConfig) {
-        return AnnotationApiFp(this.configuration).annotationGet(annotationGetRequest, options).then((request) => request(this.axios, this.basePath));
+    public annotationAnnotationIdGet(annotationId: string, options?: AxiosRequestConfig) {
+        return AnnotationApiFp(this.configuration).annotationAnnotationIdGet(annotationId, options).then((request) => request(this.axios, this.basePath));
     }
 
     /**
@@ -1070,11 +1038,12 @@ export const DocumentApiAxiosParamCreator = function (configuration?: Configurat
     return {
         /**
          * 
-         * @param {DocumentListRequest} [documentListRequest] 
+         * @param {number} [pageIndex] 
+         * @param {number} [pageSize] 
          * @param {*} [options] Override http request option.
          * @throws {RequiredError}
          */
-        documentsGet: async (documentListRequest?: DocumentListRequest, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
+        documentsGet: async (pageIndex?: number, pageSize?: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
             const localVarPath = `/documents`;
             // use dummy base URL string because the URL constructor only accepts absolute URLs.
             const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
@@ -1087,14 +1056,19 @@ export const DocumentApiAxiosParamCreator = function (configuration?: Configurat
             const localVarHeaderParameter = {} as any;
             const localVarQueryParameter = {} as any;
 
+            if (pageIndex !== undefined) {
+                localVarQueryParameter['pageIndex'] = pageIndex;
+            }
 
-    
-            localVarHeaderParameter['Content-Type'] = 'application/json';
+            if (pageSize !== undefined) {
+                localVarQueryParameter['pageSize'] = pageSize;
+            }
 
+
+    
             setSearchParams(localVarUrlObj, localVarQueryParameter);
             let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
             localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
-            localVarRequestOptions.data = serializeDataIfNeeded(documentListRequest, localVarRequestOptions, configuration)
 
             return {
                 url: toPathString(localVarUrlObj),
@@ -1146,12 +1120,13 @@ export const DocumentApiFp = function(configuration?: Configuration) {
     return {
         /**
          * 
-         * @param {DocumentListRequest} [documentListRequest] 
+         * @param {number} [pageIndex] 
+         * @param {number} [pageSize] 
          * @param {*} [options] Override http request option.
          * @throws {RequiredError}
          */
-        async documentsGet(documentListRequest?: DocumentListRequest, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DocumentListResponse>> {
-            const localVarAxiosArgs = await localVarAxiosParamCreator.documentsGet(documentListRequest, options);
+        async documentsGet(pageIndex?: number, pageSize?: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<DocumentListResponse>> {
+            const localVarAxiosArgs = await localVarAxiosParamCreator.documentsGet(pageIndex, pageSize, options);
             return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
         },
         /**
@@ -1176,12 +1151,13 @@ export const DocumentApiFactory = function (configuration?: Configuration, baseP
     return {
         /**
          * 
-         * @param {DocumentListRequest} [documentListRequest] 
+         * @param {number} [pageIndex] 
+         * @param {number} [pageSize] 
          * @param {*} [options] Override http request option.
          * @throws {RequiredError}
          */
-        documentsGet(documentListRequest?: DocumentListRequest, options?: any): AxiosPromise<DocumentListResponse> {
-            return localVarFp.documentsGet(documentListRequest, options).then((request) => request(axios, basePath));
+        documentsGet(pageIndex?: number, pageSize?: number, options?: any): AxiosPromise<DocumentListResponse> {
+            return localVarFp.documentsGet(pageIndex, pageSize, options).then((request) => request(axios, basePath));
         },
         /**
          * 
@@ -1204,13 +1180,14 @@ export const DocumentApiFactory = function (configuration?: Configuration, baseP
 export class DocumentApi extends BaseAPI {
     /**
      * 
-     * @param {DocumentListRequest} [documentListRequest] 
+     * @param {number} [pageIndex] 
+     * @param {number} [pageSize] 
      * @param {*} [options] Override http request option.
      * @throws {RequiredError}
      * @memberof DocumentApi
      */
-    public documentsGet(documentListRequest?: DocumentListRequest, options?: AxiosRequestConfig) {
-        return DocumentApiFp(this.configuration).documentsGet(documentListRequest, options).then((request) => request(this.axios, this.basePath));
+    public documentsGet(pageIndex?: number, pageSize?: number, options?: AxiosRequestConfig) {
+        return DocumentApiFp(this.configuration).documentsGet(pageIndex, pageSize, options).then((request) => request(this.axios, this.basePath));
     }
 
     /**
diff --git a/webapp/pages/annotation/[id].tsx b/webapp/pages/annotation/[id].tsx
new file mode 100644
index 0000000..8afde00
--- /dev/null
+++ b/webapp/pages/annotation/[id].tsx
@@ -0,0 +1,33 @@
+import { AnnotationPanel } from '../../components/annotation/AnnotationPanel';
+import { DocumentAnnotationView } from '../../components/annotation/DocumentAnnotationView';
+import { TagPanel } from '../../components/annotation/TagPanel';
+import { MainLayout } from '../../layouts/MainLayout';
+import 'antd/dist/antd.css';
+import styles from '/styles/Annotation.module.scss';
+import AnnotationProvider from '../../contexts/AnnotationContext';
+
+/**
+ * Creates an annotation screen.
+ * @returns The annotation screen.
+ */
+function Annotation() {
+    return (
+        <AnnotationProvider>
+            <MainLayout>
+                <div className={styles.layoutWrapper}>
+                    <div className={styles.tags}>
+                        <TagPanel />
+                    </div>
+                    <div className={styles.document}>
+                        <DocumentAnnotationView />
+                    </div>
+                    <div className={styles.annotations}>
+                        <AnnotationPanel />
+                    </div>
+                </div>
+            </MainLayout>
+        </AnnotationProvider>
+    );
+}
+
+export default Annotation;
diff --git a/webapp/pages/annotation/index.tsx b/webapp/pages/annotation/index.tsx
deleted file mode 100644
index 8afde00..0000000
--- a/webapp/pages/annotation/index.tsx
+++ /dev/null
@@ -1,33 +0,0 @@
-import { AnnotationPanel } from '../../components/annotation/AnnotationPanel';
-import { DocumentAnnotationView } from '../../components/annotation/DocumentAnnotationView';
-import { TagPanel } from '../../components/annotation/TagPanel';
-import { MainLayout } from '../../layouts/MainLayout';
-import 'antd/dist/antd.css';
-import styles from '/styles/Annotation.module.scss';
-import AnnotationProvider from '../../contexts/AnnotationContext';
-
-/**
- * Creates an annotation screen.
- * @returns The annotation screen.
- */
-function Annotation() {
-    return (
-        <AnnotationProvider>
-            <MainLayout>
-                <div className={styles.layoutWrapper}>
-                    <div className={styles.tags}>
-                        <TagPanel />
-                    </div>
-                    <div className={styles.document}>
-                        <DocumentAnnotationView />
-                    </div>
-                    <div className={styles.annotations}>
-                        <AnnotationPanel />
-                    </div>
-                </div>
-            </MainLayout>
-        </AnnotationProvider>
-    );
-}
-
-export default Annotation;